<template>
    <div class="control-userBigTable wow fadeInUp">
        <p class="text-allMoney">{{ $t('users.withdraws.total') }}   <span>{{ total_amount }}</span></p>
        <p class="text-bold">{{ $t('users.withdraws.title') }}</p>
        <div class="text-headTwo">
            <div class="text-head--left">
                <p class="text-id">{{ $t('users.withdraws.id') }}</p>
                <p class="text-id">{{ $t('users.withdraws.date') }}</p>
                <p class="text-id">{{ $t('users.withdraws.amount') }}</p>
                <p class="text-id">{{ $t('users.withdraws.wallet') }}</p>
            </div>
            <div class="text-head--right">
                <p class="text-id">{{ $t('users.withdraws.system') }}</p>
            </div>
        </div>
        <div class="body--elementTwo" v-for="withdraw in withdraws">
            <div class="body__element--left">
                <p class="text-idBold">#{{ withdraw.id }}</p>
                <p class="text-id">{{ formatDate(withdraw.created_at) }}</p>
                <p class="text-idBlue">{{ formatAmount(withdraw.amount, withdraw.currency) }}</p>
                <p class="text-id">{{ withdraw.wallet.wallet }}</p>

            </div>
            <div class="body__element--right">
                <p class="text-id"><span>{{ withdraw.payment_system.code }}</span>  ({{ withdraw.payment_system.currency.code_iso }})</p>
            </div>
        </div>
        <paginator
            :current-page="currentPage"
            :last-page="lastPage"
            :per-page="perPage"
            :items-count="total"
            @page-changed="setPage"
        />
    </div>
</template>

<script>
    import {mapGetters} from "vuex";
    import currencies from "../../currencies";
	import _ from "lodash";

	export default {
		name: "ShortWithdraws",
        props: ['user'],
        data(){
            return {
                currentPage: 0,
                lastPage: 0,
                perPage: 0,
                total: 0,
                page: 1,
                withdraws: [],
				amounts: {}
            }
        },
        computed: {
            ...mapGetters([
                'axios'
            ]),
			total_amount(){
				console.log(currencies);
				return currencies.format(_.reduce(this.amounts, (sum, value, key) => {
					let id = Number.parseInt(key);
					let amount = Number.parseFloat(value);
					let currency = currencies.getById(id);
					let amount_in_default = Number.parseFloat(currencies.convertToDefault(amount, currency));
					console.log(amount_in_default);
					return sum + amount_in_default;
				}, 0))
			}
        },
        methods: {
            submit(){
                this.axios.get(`users/${this.user.id}/short_withdraws`, {
                    params: {
                        page: this.page,
                    }
                })
                    .then(resp => resp.data)
                    .then(result => {
                        this.currentPage = result.operations.current_page;
                        this.lastPage = result.operations.last_page;
                        this.perPage = result.operations.per_page;
                        this.total = result.operations.total;
                        this.withdraws = result.operations.data;
                        this.amounts = result.amounts;
                    });
            },
            setPage(page){
                this.page = page;
                this.submit();
            },
            formatDate(date){
                return this.$date(date).format('DD.MM.YYYY HH:mm:ss');
            },
            formatAmount(amount, currency){
                return currencies.formatWithDefault(amount, currency);
            },
        },
        mounted(){
            this.submit();
        },
	}
</script>

<style scoped>

</style>
